package sun.awt.windows;

import java.awt.image.WritableRaster;
import java.awt.Graphics;
import sun.awt.image.IntegerComponentRaster;
import java.awt.image.DataBufferInt;
import sun.awt.image.ToolkitImage;
import java.awt.image.BufferedImage;
import java.awt.Point;
import java.awt.Image;
import sun.awt.CustomCursor;

final class WCustomCursor extends CustomCursor
{
    WCustomCursor(Image cursor, Point hotSpot, String name) throws IndexOutOfBoundsException {
        super(cursor, hotSpot, name);
    }
    
    @Override
    protected void createNativeCursor(Image image, int[] array, int width, int height, int n, int n2) {
        BufferedImage bufferedImage = new BufferedImage(width, height, 1);
        Graphics graphics = bufferedImage.getGraphics();
        try {
            if ((image instanceof ToolkitImage)) {
                ((ToolkitImage)image).getImageRep().reconstruct(32);
            }
            graphics.drawImage(image, 0, 0, width, height, null);
        }
        finally {
            graphics.dispose();
        }
        WritableRaster raster = bufferedImage.getRaster();
        ((DataBufferInt)raster.getDataBuffer()).getData();
        byte[] array2 = new byte[width * height / 8];
        for (int length = array.length, i = 0; i < length; ++i) {
            int n3 = i / 8;
            int n4 = 1 << 7 - i % 8;
            if ((array[i] & 0xFF000000) == 0x0) {
                int n5 = n3;
                array2[n5] |= n4;
            }
        }
        int n6 = raster.getWidth();
        if ((raster instanceof IntegerComponentRaster)) {
            n6 = ((IntegerComponentRaster)raster).getScanlineStride();
        }
        this.createCursorIndirect(((DataBufferInt)bufferedImage.getRaster().getDataBuffer()).getData(), array2, n6, raster.getWidth(), raster.getHeight(), n, n2);
    }
    
    private native void createCursorIndirect(int[] p0, byte[] p1, int p2, int p3, int p4, int p5, int p6);
    
    static native int getCursorWidth();
    
    static native int getCursorHeight();
}
